package com.ruoyi.ems.mapper;

import com.ruoyi.ems.domain.ElecMeterH;
import com.ruoyi.ems.domain.MeterDevice;
import com.ruoyi.ems.model.QueryDevice;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 计量设备Mapper接口
 *
 * @author ruoyi
 * @date 2024-08-08
 */
public interface MeterDeviceMapper {
    /**
     * 查询计量设备
     *
     * @param id 计量设备主键
     * @return 计量设备
     */
    MeterDevice selectMeterDeviceById(Long id);

    /**
     * 查询计量设备
     *
     * @param deviceCode 设备code
     * @return 计量设备
     */
    MeterDevice selectMeterDeviceByCode(@Param("deviceCode") String deviceCode);

    List<MeterDevice> selectMeterDeviceByObj(@Param("areaCode") String areaCode, @Param("meterCls") Integer meterCls,
        @Param("colMode") Integer colMode, @Param("objType") Integer objType, @Param("objCode") String objCode);

    List<MeterDevice> selectMeterDevByTag(@Param("tagCode") String tagCode,
        @Param("queryDevice") QueryDevice queryDevice);

    /**
     * 查询计量设备列表
     *
     * @param queryDevice 计量设备
     * @return 计量设备集合
     */
    List<MeterDevice> selectMeterDeviceList(QueryDevice queryDevice);

    /**
     * 查询计量设备列表
     *
     * @param deviceModel 设备型号
     * @return 计量设备集合
     */
    List<MeterDevice> selectByModel(String deviceModel);

    /**
     * 新增计量设备
     *
     * @param meterDevice 计量设备
     * @return 结果
     */
    int insertMeterDevice(MeterDevice meterDevice);

    /**
     * 修改计量设备
     *
     * @param meterDevice 计量设备
     * @return 结果
     */
    int updateMeterDevice(MeterDevice meterDevice);

    /**
     * 删除计量设备
     *
     * @param id 计量设备主键
     * @return 结果
     */
    int deleteMeterDeviceById(Long id);

    /**
     * 批量删除计量设备
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteMeterDeviceByIds(Long[] ids);

    int countMeterDeviceByObj(MeterDevice meterDevice);

    int countOnlineMeterDeviceByObj(ElecMeterH elecMeterH);

}
